/************************************************
 **
 **    *** HAPPy P-code Interpreter ***
 **
 **             C
 **
 **          Copyright (c) H.Asano. 1992-1994.
 ************************************************/

#define EXTERN

#include <signal.h>
#include <process.h>
#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <float.h>
#include "version.h"
#include "hapai.h"

#define abnormal  1                     /* usage֐ւ̈          */
#define normal    0                     /* usage֐ւ̈          */

extern void interpret(void) ;   /* P-code߉ߎs             */

_store  store[Maxstore] ;       /* Lu                           */

_store *sp   ;                  /* stack pointer                      */
short   pc   ;                  /* program counter                    */
short   mp   ;                  /* begginning of a data segment       */
short   ep   ;                  /* the maxmum extent of the stack     */
short   np   ;                  /* top of the dynamically allocated area */

_code   cd   ;                  /* P-code                             */

short   fileno   ;              /* t@C                         */

boolean trace             ;     /* ߃g[XtO                 */
boolean readlnflag = true ;     /* Nyinputreadln ^ */

const  char *ext = ".pco" ;     /* P-codeIvWFNgt@C̊gq */
static char pcofname[50]  ;     /* P-codeIuWFNgt@C       */
static char progname[33]  ;     /* PascalvO                 */

static short   objsize  ;
static FILE    *pcofile ;
static boolean infor = false ;          /* -i߼  o  */
static boolean fileoptflag = false ;    /* /f߼  ̧ٖw       */
static short   fno      ;               /* /f߼݂Ŏ擾ِ̧   */
static int     wargc    ;               /* argc ޔ                  */
static char    **wargv  ;               /* argv ޔ                  */

/******************************************/
/*  puteoln() : Ieolnt^      */
/******************************************/
void puteoln(void)
{
   short i ;

     for(i=0;i<fileno;i++) {            /* t@CN[Ys     */
      if((fi[i].mode == generation) &&  /* [hŃeLXg     */
         (fi[i].textfile) && (!fi[i].writelnflag)) /* ŌオsłȂ*/
        fputc('\n',fi[i].fp) ;          /* st           */
      fclose(fi[i].fp) ;                /* G[`FbN͂Ȃ     */
     }
}

/******************************/
/* title() : ^Cg\ */
/******************************/
static void title(void)
{
  static putflag = false ;

  if(!putflag) {                        /* x\           */
   fprintf(stderr,
    "HAPPy P-code Interpreter Version %s  Copyright (c) H.Asano 1992-1994.\n",
                                    version) ;
   putflag = true ;
  }
}

/******************************************/
/* prerr() : Run-timeG[bZ[Wo */
/******************************************/
void prerr(short errno,char *msg)
{
     fprintf(stderr,"\n*** [ADDR=%d] HAPPy Run-time error R%03d:\n   --  %s",
                    pc-1,errno,msg) ;
     fputs(" : ł؂ ***\n",stderr);
     puteoln() ;                        /* t@CN[Y & eolnt^*/
     exit(1)   ;                        /* ^CG[ŏI     */
}

/**********************************************/
/* pierr() : C^v^G[bZ[Wo */
/**********************************************/
static void pierr(char *msg, char *umecomi)
{
     title() ;
     fprintf(stderr,msg,umecomi) ;
     exit(2) ;                          /* ̑̃G[ŏI       */
}

/****************************************/
/*   cntl_c(): cntl_cꂽ̏ */
/****************************************/
static void cntl_c(int sig, int subcode)
{
     prerr(152,"<CTRL-C>󂯕t");
}

/****************************************/
/*   real_err(): _O         */
/****************************************/
static void real_err(int sig, int subcode)
{
  char *type ;
  char buf[80] ;

     switch(subcode) {
      case FPE_INVALID        : type = "invalid";             break ;
      case FPE_OVERFLOW       : type = "overflow";            break ;
      case FPE_STACKOVERFLOW  : type = "stack overflow";      break ;
      case FPE_STACKUNDERFLOW : type = "stack underflow";     break ;
     }
     sprintf(buf,"Zňُ킪N(%s)",type) ;
     prerr(150,buf) ;
}

/******************************/
/* usage() : gp@o͏ */
/******************************/
static void usage(short type)
{
 title() ;
 if(type==abnormal) fputs("\nI004: Np[^Ă\n",stderr);
 else  {                                /* pi ݂̂ ޭĂȂ̎ */
  fputs("\n  HAPPy is the H.Asano Pascal Processing system. (^_^)\n",
             stderr);
  fputs(
   "\n  HAPPyISO7185Ki0ɂقڏMS-DOSėpPascalnłB\n",
            stderr) ;
  fputs("  HAPPy̕ʁEĔzt͎RłB\n", stderr) ;
 }

 fputs("\n  piނpcނōP-code޼ުĂs܂B\n\n",stderr);

 fputs("  g:  pi [ ߼...] P-code޼ު̧ٖ[.pco] [ ߼...]\n",
       stderr) ;
 fputs("  ߼:\n",stderr);
 fputs("     -i  C^v^o͂\n",stderr);
 fputs("     -t  g[XWo͂ɏo͂\n",stderr);
 fputs("     /f  vÕt@CƎt@CΉ\n",
        stderr);
 fputs("                 :  /fputfile=h:\\work\\list.txt\n",stderr) ;

 exit(2) ;
}

/************************************/
/* information() : -iIvV */
/************************************/
static void information(void)
{
  short i,j     ;
  short max = 0 ;

     title()  ;
     fprintf(stderr,"\n * Program name = %s\n",progname) ;
     fprintf(stderr," * Total memory = %5d words\n",Maxstore) ;
     fprintf(stderr," * Object size  = %5d words\n",objsize)  ;
     fprintf(stderr," * stack/heap   = %5d words\n",Maxstore-objsize) ;
     if(fileno!=2) {
      fputs(" * input,outputȊÕt@CƎt@C̑Ή\n",stderr) ;
      for(i=2;i<fileno;i++)
       if(strlen(fi[i].filename) > max) max = strlen(fi[i].filename) ;
      for(i=2;i<fileno;i++) {
       fprintf(stderr,"    %s",fi[i].filename) ;
       for(j=strlen(fi[i].filename);j<max;j++)
        fputc(' ',stderr) ;             /* ő̒ɍ킹邽   */
       fprintf(stderr," = %s\n",fi[i].rfname) ;
      }
     }
     fputc('\n',stderr) ;
}

/******************************************/
/*  fileoption() : t@CIvV */
/******************************************/
static void fileoption(char *fileopt)
{
  short i=0 ;
  short j   ;
  short len ;
  char logicalf[MaxIDlng+1] ;           /* vÕt@C   */

     if(fileno==2) usage(abnormal) ;    /* ̧ٖgp /f  ws*/

     while(*(fileopt+i)!='=') i++ ;     /* vÕt@C擾*/
     if(i>MaxIDlng) i=MaxIDlng ;
     for(j=0;j<i;j++)
      logicalf[j] = (char)tolower(*(fileopt+j)) ;
     logicalf[i] = '\0' ;

     j=2;
     while((j<fileno) &&
           strcmp(fi[j].filename,logicalf)) j++ ;
     if(j==fileno) {                 /* vOŎgĂȂ*/
      title() ;
      fprintf(stderr,"I005:/fIvV(%s) : \n",fileopt) ;
      return ;
     }
     if(fi[j].askflag) {                /* ܂/f߼݂Ŗ̧ */
      fi[j].askflag = false ;
      fno++ ;                           /* /f߼  w肵ِ̧ */
     }
     len = strlen(fileopt)-i-1 ;
     if(len > MaxRFlen) len = MaxRFlen ;
     strncpy(fi[j].rfname,fileopt+i+1,len) ;
     fi[j].rfname[len] = '\0' ;
}

/*****************************************/
/*  inputfilename() : t@C͏ */
/*****************************************/
static void inputfilename(void)
{
  short i,j ;
  short  ch ;

     title() ;
     fputs("*HAPPy: t@C( ",stderr) ;
     for(i=2;i<fileno;i++)
      if(fi[i].askflag)  fprintf(stderr,"%s ",fi[i].filename) ;
     fputs(")̎t@C͂ĉ\n",stderr);

     for(i=2;i<fileno;i++)
      if(fi[i].askflag) {
       fprintf(stderr," %s : ",fi[i].filename) ;
       while(((ch=getc(stdin)) == ' ') || (ch == '\t'));
                                        /* ,^u̓ǂݔ΂      */
       j = 0 ;
       while(ch != '\n') {
        fi[i].rfname[j++] = (char)ch ;
        if(j == MaxRFlen) break ;
        ch = getc(stdin) ;
       }  ;
       fi[i].rfname[j] = '\0' ;
      }
     fputs("*HAPPy: t@C͏I *\n\n",stderr) ;
}

/***************************************/
/*   fcheck() : t@C`FbN    */
/***************************************/
static void fcheck(void)
{
     if(feof(pcofile))            /* rŃt@CIĂ܂*/
      pierr("I002: P-codeIuWFNgt@C(%s)sł",pcofname) ;
}

/***************************************/
/*      init() :  ݒ菈         */
/***************************************/
static void init(void)
{
  short i   ;
  char ch   ;
  short headerlen     ;                 /* wb_̒           */
  char compversion[6] ;                 /* RpCo[Wԍ   */

  /**** input,outputt@C̃t@Cݒ肷 ****/

     strcpy(fi[0].filename,"input")  ;
     fi[0].fileadr  = inputadr       ;
     fi[0].filesize = 1              ;
     strcpy(fi[0].rfname,"W") ;
     fi[0].fp       = stdin          ;  /* W                   */
     fi[0].mode     = inspection     ;  /* [h                 */
     fi[0].textfile = true           ;  /* eLXgt@C           */

     strcpy(fi[1].filename,"output") ;
     fi[1].fileadr  = outputadr      ;
     fi[1].filesize = 1              ;
     strcpy(fi[1].rfname,"Wo") ;
     fi[1].fp       = stdout         ;  /* Wo                   */
     fi[1].mode     = generation     ;  /* [h                 */
     fi[1].textfile = true           ;  /* eLXgt@C           */
     fi[1].writelnflag = true        ;

     fileno = fno = 2 ;

     objsize = (short)filelength(fileno(pcofile));
     i = 0 ;
     do {                               /* o[Wԍǂ       */
      ch = (char)fgetc(pcofile) ;
      fcheck() ;
     } while((compversion[i++]=ch)) ;
     headerlen = i ;
     if(strcmp(compversion,version))
      pierr(
       "I003: RpC(Version %s)ƃo[WvȂ\n",compversion) ;
     i = 0 ;
     do {                               /* vOǂ         */
      progname[i] = (char)fgetc(pcofile) ;
      fcheck() ;
     } while(progname[i++]) ;
     headerlen += i ;

     while((fi[fileno].fileadr = getw(pcofile)) != -1) {
      fcheck() ;
      headerlen += sizeof(short) ;
      fi[fileno].filesize = getw(pcofile) ; /* obt@ϐ̑傫   */
      headerlen += sizeof(short) ;
      i = 0 ;
      do {                               /* t@Cǂ          */
       fi[fileno].filename[i] = (char)fgetc(pcofile) ;
       fcheck() ;
      } while(fi[fileno].filename[i++]) ;
      fi[fileno].mode = undefined  ;    /* t@C[h͕s       */
      fi[fileno].askflag  = true   ;    /* ̧ٖ₢킹vƂĂ*/
      fi[fileno].textfile = false  ;    /* eLXgłȂƂĂ   */

      headerlen += i ;
      fileno++ ;
     }
     fcheck() ;

     headerlen += sizeof(short) ;
     objsize   -= headerlen ;
     fread((char*)store,objsize,1,pcofile) ; /* P-codeIuWFNgǂ*/
     objsize /= sizeof(_store) ;

     for(i=0;i<fileno;i++) {
      fi[i].fileadr += objsize ;        /* t@CAhX̏C     */
      fi[i].filebuf =  store + fi[i].fileadr ; /* obt@ϐAhX*/
     }
}

/******************************************/
/*  main() : P-codeC^v^C */
/******************************************/
void main(int argc,char **argv)
{
  short i,j ;
  boolean getfileflag = false ;

     wargc = argc ;
     wargv = argv ;

     if(argc < 2)  usage(normal);       /* A[MgȂusage  */

     while(--argc) {                    /* IvV̏           */
      if(**++argv == '-') {
       for(i=1;*(*argv+i)!='\0';i++)
        switch(*(*argv+i)) {
         case 'I' :
         case 'i' : infor = true   ;    /* information option         */
                    break          ;
         case 'T' :
         case 't' : trace = true   ;    /* trace option               */
                     break         ;
         default  : usage(abnormal);    /* -t -i ȊO̓G[         */
        }
       if(i==1)  usage(abnormal);       /* - ̎usage          */
      }
      else if(**argv == '/') {
       if((*(*argv+1) == 'f') || (*(*argv+1) == 'F')) {
        j=2 ;
        while((*(*argv+j)) &&           /* /f= ł邱    */
              (*(*argv+j)!='=')) j++ ;  /*    `FbN          */
        if((*(*argv+j)!='=') ||         /*   = Ȃ                 */
           !(*(*argv+j+1))   ||         /*   = ŏIĂ         */
            (j==2))   usage(abnormal) ; /*   /f ̂                  */
        fileoptflag = true ;            /* /f߼               */
       }
      }
      else {                            /* - / n܂Ȃޭ */
       if(getfileflag) {                /* łɃ\[Xt@C   */
         usage(abnormal);               /* 擾Ă鎞       */
         break ;                        /* while[vEo            */
       }
       getfileflag = true      ;        /* t@C擾ςƂ     */
       *pcofname   = '\0'      ;
       strcpy(pcofname, *argv) ;
       j=0 ;                             /* gqȗĂ邩   */
       while((*(pcofname+j)!='\0') && (*(pcofname+j)!='.')) j++ ;
       if(*(pcofname+j)=='\0') strcat(pcofname,ext) ; /* gqt^  */
      }
     }

     if(getfileflag) {                  /* t@Cw肳ꂽ   */
      pcofile = fopen(pcofname,"rb");
      if(pcofile==NULL)
       pierr("I001: P-codeIuWFNgt@C(%s)Ȃ\n",pcofname);
     }
     else usage(abnormal) ;             /* t@C̎w肪Ȃ   */

     init()          ;                  /* e평ݒ               */

     if(fileoptflag)                    /* /f߼݂               */
      while(--wargc)
       if(**++wargv == '/')
        if((*(*wargv+1) == 'f') || (*(*wargv+1) == 'F'))
         fileoption(*wargv+2) ;

     if(fileno!=fno) inputfilename() ;  /* Şق肵ĂȂ   */

     if(infor) information() ;          /* -i  o        */


     signal(SIGINT,cntl_c) ;            /* CTRL-CVOio^         */
     signal(SIGFPE,real_err) ;          /* ZVOio^       */

     pc = 0          ;                  /* Program Counter ݒ   */
     mp = objsize    ;                  /* mp              ݒ   */
     ep = mp + 5     ;                  /* ep              ݒ   */
     np = Maxstore   ;                  /* np              ݒ   */
     sp = store+mp-1 ;                  /* Stack Pointer   ݒ   */

     interpret() ;                      /* P-code߉ߎs         */
}
